#include <inline/stub.h>
#ifndef BASE_EXT_DECL
#define BASE_EXT_DECL extern struct DosLibrary * DOSBase;
#endif
#ifndef BASE_PAR_DECL
#define BASE_PAR_DECL
#define BASE_PAR_DECL0 void
#endif
#ifndef BASE_NAME
#define BASE_NAME DOSBase
#endif
__inline static BPTR Open(BASE_PAR_DECL const UBYTE* name, long int accessMode)
{
	BASE_EXT_DECL
	register BPTR res __asm("d0");
	register void *a6 __asm ("a6");
	register const UBYTE* d1 __asm("d1");
	register long int d2 __asm("d2");

	a6 = BASE_NAME;
	d1 = name;
	d2 = accessMode;
	__asm volatile ("
	jsr a6@(-0x1e)"
	: "=r" (res)
	: "r" (a6), "r" (d1), "r" (d2)
	: "d0", "d1", "a0", "a1", "d2");
	return res;
}
__inline static LONG Close(BASE_PAR_DECL BPTR file)
{
	BASE_EXT_DECL
	register LONG res __asm("d0");
	register void *a6 __asm ("a6");
	register BPTR d1 __asm("d1");

	a6 = BASE_NAME;
	d1 = file;
	__asm volatile ("
	jsr a6@(-0x24)"
	: "=r" (res)
	: "r" (a6), "r" (d1)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static LONG Read(BASE_PAR_DECL BPTR file, UBYTE* buffer, long int length)
{
	BASE_EXT_DECL
	register LONG res __asm("d0");
	register void *a6 __asm ("a6");
	register BPTR d1 __asm("d1");
	register UBYTE* d2 __asm("d2");
	register long int d3 __asm("d3");

	a6 = BASE_NAME;
	d1 = file;
	d2 = buffer;
	d3 = length;
	__asm volatile ("
	jsr a6@(-0x2a)"
	: "=r" (res)
	: "r" (a6), "r" (d1), "r" (d2), "r" (d3)
	: "d0", "d1", "a0", "a1", "d2", "d3");
	*(char *)d2=*(char *)d2;
	return res;
}
__inline static LONG Write(BASE_PAR_DECL BPTR file, const UBYTE* buffer, long int length)
{
	BASE_EXT_DECL
	register LONG res __asm("d0");
	register void *a6 __asm ("a6");
	register BPTR d1 __asm("d1");
	register const UBYTE* d2 __asm("d2");
	register long int d3 __asm("d3");

	a6 = BASE_NAME;
	d1 = file;
	d2 = buffer;
	d3 = length;
	__asm volatile ("
	jsr a6@(-0x30)"
	: "=r" (res)
	: "r" (a6), "r" (d1), "r" (d2), "r" (d3)
	: "d0", "d1", "a0", "a1", "d2", "d3");
	return res;
}
__inline static BPTR Input(BASE_PAR_DECL0)
{
	BASE_EXT_DECL
	register BPTR res __asm("d0");
	register void *a6 __asm ("a6");
	a6 = BASE_NAME;
	__asm volatile ("
	jsr a6@(-0x36)"
	: "=r" (res)
	: "r" (a6)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static BPTR Output(BASE_PAR_DECL0)
{
	BASE_EXT_DECL
	register BPTR res __asm("d0");
	register void *a6 __asm ("a6");
	a6 = BASE_NAME;
	__asm volatile ("
	jsr a6@(-0x3c)"
	: "=r" (res)
	: "r" (a6)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static LONG Seek(BASE_PAR_DECL BPTR file, long int position, long int offset)
{
	BASE_EXT_DECL
	register LONG res __asm("d0");
	register void *a6 __asm ("a6");
	register BPTR d1 __asm("d1");
	register long int d2 __asm("d2");
	register long int d3 __asm("d3");

	a6 = BASE_NAME;
	d1 = file;
	d2 = position;
	d3 = offset;
	__asm volatile ("
	jsr a6@(-0x42)"
	: "=r" (res)
	: "r" (a6), "r" (d1), "r" (d2), "r" (d3)
	: "d0", "d1", "a0", "a1", "d2", "d3");
	return res;
}
__inline static LONG DeleteFile(BASE_PAR_DECL const UBYTE* name)
{
	BASE_EXT_DECL
	register LONG res __asm("d0");
	register void *a6 __asm ("a6");
	register const UBYTE* d1 __asm("d1");

	a6 = BASE_NAME;
	d1 = name;
	__asm volatile ("
	jsr a6@(-0x48)"
	: "=r" (res)
	: "r" (a6), "r" (d1)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static LONG Rename(BASE_PAR_DECL const UBYTE* oldName, const UBYTE* newName)
{
	BASE_EXT_DECL
	register LONG res __asm("d0");
	register void *a6 __asm ("a6");
	register const UBYTE* d1 __asm("d1");
	register const UBYTE* d2 __asm("d2");

	a6 = BASE_NAME;
	d1 = oldName;
	d2 = newName;
	__asm volatile ("
	jsr a6@(-0x4e)"
	: "=r" (res)
	: "r" (a6), "r" (d1), "r" (d2)
	: "d0", "d1", "a0", "a1", "d2");
	return res;
}
__inline static BPTR Lock(BASE_PAR_DECL const UBYTE* name, long int type)
{
	BASE_EXT_DECL
	register BPTR res __asm("d0");
	register void *a6 __asm ("a6");
	register const UBYTE* d1 __asm("d1");
	register long int d2 __asm("d2");

	a6 = BASE_NAME;
	d1 = name;
	d2 = type;
	__asm volatile ("
	jsr a6@(-0x54)"
	: "=r" (res)
	: "r" (a6), "r" (d1), "r" (d2)
	: "d0", "d1", "a0", "a1", "d2");
	return res;
}
__inline static void UnLock(BASE_PAR_DECL BPTR lock)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register BPTR d1 __asm("d1");

	a6 = BASE_NAME;
	d1 = lock;
	__asm volatile ("
	jsr a6@(-0x5a)"
	: /* no output */
	: "r" (a6), "r" (d1)
	: "d0", "d1", "a0", "a1");
}
__inline static BPTR DupLock(BASE_PAR_DECL BPTR lock)
{
	BASE_EXT_DECL
	register BPTR res __asm("d0");
	register void *a6 __asm ("a6");
	register BPTR d1 __asm("d1");

	a6 = BASE_NAME;
	d1 = lock;
	__asm volatile ("
	jsr a6@(-0x60)"
	: "=r" (res)
	: "r" (a6), "r" (d1)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static LONG Examine(BASE_PAR_DECL BPTR lock, struct FileInfoBlock* fileInfoBlock)
{
	BASE_EXT_DECL
	register LONG res __asm("d0");
	register void *a6 __asm ("a6");
	register BPTR d1 __asm("d1");
	register struct FileInfoBlock* d2 __asm("d2");

	a6 = BASE_NAME;
	d1 = lock;
	d2 = fileInfoBlock;
	__asm volatile ("
	jsr a6@(-0x66)"
	: "=r" (res)
	: "r" (a6), "r" (d1), "r" (d2)
	: "d0", "d1", "a0", "a1", "d2");
	*(char *)d2=*(char *)d2;
	return res;
}
__inline static LONG ExNext(BASE_PAR_DECL BPTR lock, struct FileInfoBlock* fileInfoBlock)
{
	BASE_EXT_DECL
	register LONG res __asm("d0");
	register void *a6 __asm ("a6");
	register BPTR d1 __asm("d1");
	register struct FileInfoBlock* d2 __asm("d2");

	a6 = BASE_NAME;
	d1 = lock;
	d2 = fileInfoBlock;
	__asm volatile ("
	jsr a6@(-0x6c)"
	: "=r" (res)
	: "r" (a6), "r" (d1), "r" (d2)
	: "d0", "d1", "a0", "a1", "d2");
	*(char *)d2=*(char *)d2;
	return res;
}
__inline static LONG Info(BASE_PAR_DECL BPTR lock, struct InfoData* parameterBlock)
{
	BASE_EXT_DECL
	register LONG res __asm("d0");
	register void *a6 __asm ("a6");
	register BPTR d1 __asm("d1");
	register struct InfoData* d2 __asm("d2");

	a6 = BASE_NAME;
	d1 = lock;
	d2 = parameterBlock;
	__asm volatile ("
	jsr a6@(-0x72)"
	: "=r" (res)
	: "r" (a6), "r" (d1), "r" (d2)
	: "d0", "d1", "a0", "a1", "d2");
	*(char *)d2=*(char *)d2;
	return res;
}
__inline static BPTR CreateDir(BASE_PAR_DECL const UBYTE* name)
{
	BASE_EXT_DECL
	register BPTR res __asm("d0");
	register void *a6 __asm ("a6");
	register const UBYTE* d1 __asm("d1");

	a6 = BASE_NAME;
	d1 = name;
	__asm volatile ("
	jsr a6@(-0x78)"
	: "=r" (res)
	: "r" (a6), "r" (d1)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static BPTR CurrentDir(BASE_PAR_DECL BPTR lock)
{
	BASE_EXT_DECL
	register BPTR res __asm("d0");
	register void *a6 __asm ("a6");
	register BPTR d1 __asm("d1");

	a6 = BASE_NAME;
	d1 = lock;
	__asm volatile ("
	jsr a6@(-0x7e)"
	: "=r" (res)
	: "r" (a6), "r" (d1)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static LONG IoErr(BASE_PAR_DECL0)
{
	BASE_EXT_DECL
	register LONG res __asm("d0");
	register void *a6 __asm ("a6");
	a6 = BASE_NAME;
	__asm volatile ("
	jsr a6@(-0x84)"
	: "=r" (res)
	: "r" (a6)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static struct MsgPort* CreateProc(BASE_PAR_DECL const UBYTE* name, long int pri, BPTR segList, long int stackSize)
{
	BASE_EXT_DECL
	register struct MsgPort* res __asm("d0");
	register void *a6 __asm ("a6");
	register const UBYTE* d1 __asm("d1");
	register long int d2 __asm("d2");
	register BPTR d3 __asm("d3");
	register long int d4 __asm("d4");

	a6 = BASE_NAME;
	d1 = name;
	d2 = pri;
	d3 = segList;
	d4 = stackSize;
	__asm volatile ("
	jsr a6@(-0x8a)"
	: "=r" (res)
	: "r" (a6), "r" (d1), "r" (d2), "r" (d3), "r" (d4)
	: "d0", "d1", "a0", "a1", "d2", "d3", "d4");
	return res;
}
__inline static void volatile Exit(BASE_PAR_DECL long int returnCode)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register long int d1 __asm("d1");

	a6 = BASE_NAME;
	d1 = returnCode;
	__asm volatile ("
	jsr a6@(-0x90)"
	: /* no output */
	: "r" (a6), "r" (d1)
	: "d0", "d1", "a0", "a1");
}
__inline static BPTR LoadSeg(BASE_PAR_DECL const UBYTE* name)
{
	BASE_EXT_DECL
	register BPTR res __asm("d0");
	register void *a6 __asm ("a6");
	register const UBYTE* d1 __asm("d1");

	a6 = BASE_NAME;
	d1 = name;
	__asm volatile ("
	jsr a6@(-0x96)"
	: "=r" (res)
	: "r" (a6), "r" (d1)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static void UnLoadSeg(BASE_PAR_DECL BPTR seglist)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register BPTR d1 __asm("d1");

	a6 = BASE_NAME;
	d1 = seglist;
	__asm volatile ("
	jsr a6@(-0x9c)"
	: /* no output */
	: "r" (a6), "r" (d1)
	: "d0", "d1", "a0", "a1");
}
#ifdef PRIVATE
#endif
__inline static struct MsgPort* DeviceProc(BASE_PAR_DECL const UBYTE* name)
{
	BASE_EXT_DECL
	register struct MsgPort* res __asm("d0");
	register void *a6 __asm ("a6");
	register const UBYTE* d1 __asm("d1");

	a6 = BASE_NAME;
	d1 = name;
	__asm volatile ("
	jsr a6@(-0xae)"
	: "=r" (res)
	: "r" (a6), "r" (d1)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static LONG SetComment(BASE_PAR_DECL const UBYTE* name, const UBYTE* comment)
{
	BASE_EXT_DECL
	register LONG res __asm("d0");
	register void *a6 __asm ("a6");
	register const UBYTE* d1 __asm("d1");
	register const UBYTE* d2 __asm("d2");

	a6 = BASE_NAME;
	d1 = name;
	d2 = comment;
	__asm volatile ("
	jsr a6@(-0xb4)"
	: "=r" (res)
	: "r" (a6), "r" (d1), "r" (d2)
	: "d0", "d1", "a0", "a1", "d2");
	return res;
}
__inline static LONG SetProtection(BASE_PAR_DECL const UBYTE* name, long int protect)
{
	BASE_EXT_DECL
	register LONG res __asm("d0");
	register void *a6 __asm ("a6");
	register const UBYTE* d1 __asm("d1");
	register long int d2 __asm("d2");

	a6 = BASE_NAME;
	d1 = name;
	d2 = protect;
	__asm volatile ("
	jsr a6@(-0xba)"
	: "=r" (res)
	: "r" (a6), "r" (d1), "r" (d2)
	: "d0", "d1", "a0", "a1", "d2");
	return res;
}
__inline static struct DateStamp* DateStamp(BASE_PAR_DECL struct DateStamp* date)
{
	BASE_EXT_DECL
	register struct DateStamp* res __asm("d0");
	register void *a6 __asm ("a6");
	register struct DateStamp* d1 __asm("d1");

	a6 = BASE_NAME;
	d1 = date;
	__asm volatile ("
	jsr a6@(-0xc0)"
	: "=r" (res)
	: "r" (a6), "r" (d1)
	: "d0", "d1", "a0", "a1");
	*(unsigned long*) d1 = *(unsigned long*) d1;
	return res;
}
__inline static void Delay(BASE_PAR_DECL long int timeout)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register long int d1 __asm("d1");

	a6 = BASE_NAME;
	d1 = timeout;
	__asm volatile ("
	jsr a6@(-0xc6)"
	: /* no output */
	: "r" (a6), "r" (d1)
	: "d0", "d1", "a0", "a1");
}
__inline static LONG WaitForChar(BASE_PAR_DECL BPTR file, long int timeout)
{
	BASE_EXT_DECL
	register LONG res __asm("d0");
	register void *a6 __asm ("a6");
	register BPTR d1 __asm("d1");
	register long int d2 __asm("d2");

	a6 = BASE_NAME;
	d1 = file;
	d2 = timeout;
	__asm volatile ("
	jsr a6@(-0xcc)"
	: "=r" (res)
	: "r" (a6), "r" (d1), "r" (d2)
	: "d0", "d1", "a0", "a1", "d2");
	return res;
}
__inline static BPTR ParentDir(BASE_PAR_DECL BPTR lock)
{
	BASE_EXT_DECL
	register BPTR res __asm("d0");
	register void *a6 __asm ("a6");
	register BPTR d1 __asm("d1");

	a6 = BASE_NAME;
	d1 = lock;
	__asm volatile ("
	jsr a6@(-0xd2)"
	: "=r" (res)
	: "r" (a6), "r" (d1)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static LONG IsInteractive(BASE_PAR_DECL BPTR file)
{
	BASE_EXT_DECL
	register LONG res __asm("d0");
	register void *a6 __asm ("a6");
	register BPTR d1 __asm("d1");

	a6 = BASE_NAME;
	d1 = file;
	__asm volatile ("
	jsr a6@(-0xd8)"
	: "=r" (res)
	: "r" (a6), "r" (d1)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static LONG Execute(BASE_PAR_DECL const UBYTE* string, BPTR file, BPTR file2)
{
	BASE_EXT_DECL
	register LONG res __asm("d0");
	register void *a6 __asm ("a6");
	register const UBYTE* d1 __asm("d1");
	register BPTR d2 __asm("d2");
	register BPTR d3 __asm("d3");

	a6 = BASE_NAME;
	d1 = string;
	d2 = file;
	d3 = file2;
	__asm volatile ("
	jsr a6@(-0xde)"
	: "=r" (res)
	: "r" (a6), "r" (d1), "r" (d2), "r" (d3)
	: "d0", "d1", "a0", "a1", "d2", "d3");
	return res;
}
#undef BASE_EXT_DECL
#undef BASE_PAR_DECL
#undef BASE_PAR_DECL0
#undef BASE_NAME
